﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace LoadedToTheGills
{
    /// <summary>
    /// Логика взаимодействия для Menu.xaml
    /// </summary>
    public partial class Menu : Window
    {
        gr671_kyaaEntities Entity = new gr671_kyaaEntities();
       // public List<Users> userList { get; set; } 
        public String LabelText { get; set; }
        public Menu()
        {
            InitializeComponent();



            
        }

        private void Window_Loaded (object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            var users = Entity.Users.ToList();
            var leads = Entity.Lead.ToList();

            usersBox.ItemsSource = users;

            txtBoxCallDate.Text = DateTime.Now.ToString();
            txtBoxCallDate.IsReadOnly = true;
            lblName.Content = LabelText;
            var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
            int id_ = idUser_;
            txtBoxUser.Text = Convert.ToString(id_);

            if (txtBoxUser.Text == "0")
            {
                callGrid.ItemsSource = calls.ToList();
                btnAdd.IsEnabled = false;
                btnDelete.IsEnabled = false;
                btnUpdate.IsEnabled = false;
            }

            if (txtBoxUser.Text != "0")
            {
                txtBoxUser.IsReadOnly = true;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
            }

            
        }

        private void BtnDelete_Click(object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            int num = (callGrid.SelectedItem as Call).idCall;
            var idRow = Entity.Call.Where(delete => delete.idCall == num).FirstOrDefault();
            var idLead_ = Entity.Call.Where(id => id.idCall == num).Select(Call => Call.idLead).FirstOrDefault();
            int idLead__ = Convert.ToInt32(idLead_);
            var statusLead = Entity.Lead.Where(id => id.idLead == idLead__).Select(Status => Status.StatusLead).FirstOrDefault();
            if(Convert.ToString(statusLead) == "Неактивный")
            {
                MessageBox.Show("Вы не можете удалить неактивный лид");
                return;
            }
            else
            {
                Entity.Call.Remove(idRow);
                Entity.SaveChanges();
            }
            if ((String)lblName.Content == "Username")
            {
                callGrid.ItemsSource = calls;
            }
            else 
            {
                var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
                int id_ = idUser_;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
            }


        }

        private void BtnAdd_Click(object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();

            if(txtBoxCallDate.Text == "" || txtBoxLeadStart.Text == "" || txtBoxLong.Text == "" || txtBoxUser.Text == "")
            {
                MessageBox.Show("Заполнены не все данные");
                return;
            }
            else
            {
                Call call = new Call()
                {
                    CallDate = Convert.ToDateTime(txtBoxCallDate.Text),
                    LongCall = Convert.ToInt32(txtBoxLong.Text),
                    idLead = Convert.ToInt32(txtBoxLeadStart.Text),
                    idUser = Convert.ToInt32(txtBoxUser.Text)
                };
                
                Entity.Call.Add(call);
                Entity.SaveChanges();
                var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
                int id_ = idUser_;
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
                
            }
        }

        private void BtnUpdate_Click(object sender, RoutedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            int num = (callGrid.SelectedItem as Call).idCall;
            var idRow = Entity.Call.Where(grechka => grechka.idCall == num).FirstOrDefault();
            var idUser_ = Entity.Users.Where(user => user.Login == (String)lblName.Content).Select(id => id.idUser).FirstOrDefault();
            int id_ = idUser_;

            if (txtBoxCallDate.Text == "" || txtBoxLeadStart.Text == "" || txtBoxLong.Text == "" || txtBoxUser.Text == "")
            {
                MessageBox.Show("Заполнены не все данные");
                return;
            }
            else
            {
                idRow.CallDate = Convert.ToDateTime(txtBoxCallDate.Text);
                idRow.LongCall = Convert.ToInt32(txtBoxLong.Text);
                idRow.idLead = Convert.ToInt32(txtBoxLeadStart.Text);
                idRow.idUser = Convert.ToInt32(txtBoxUser.Text);
                Entity.SaveChanges();
                callGrid.ItemsSource = calls.Where(id => id.idUser == id_);
            }
        }

        private void UsersBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var calls = Entity.Call.ToList();
            int num = (usersBox.SelectedItem as Users).idUser;
            callGrid.ItemsSource = calls.Where(id => id.idUser == num);
            string num_ = Convert.ToString(num);
            if(txtBoxUser.Text != num_)
            {
                btnAdd.IsEnabled = false;
                btnDelete.IsEnabled = false;
                btnUpdate.IsEnabled = false;
            }
            if(txtBoxUser.Text == num_)
            {
                btnAdd.IsEnabled = true;
                btnDelete.IsEnabled = true;
                btnUpdate.IsEnabled = true;
            }
        }
    }
}
